<?php
/*
  *******************************************
  plugin JUpload for Coppermine Photo Gallery
  *******************************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  $Source: $
  $Revision: ?
  $Author: etienne_sf $
  $Date: $
**********************************************/



if (!defined('IN_COPPERMINE')) {
	//There can be direct access to this URL: as Coppermine central scripts (ex: login and errors) only
	//redirect to a page, without transmitting its parameters, we redirect to the plugins/jupload/jupload.php
	//Now that we are here, we redirect to  YourCoppermineInstallation/index.php?file=jupload/jupload
	
	//Let's get all GET parameters in this query, and redirect to the correct URL.
	$parameters = '';
	foreach ($_GET as $param => $value) {
		$parameters .= '&' . urlencode($param) . '=' . urlencode($value);
	}
	echo <<<EOS
	<script language="javascript">
	document.location.replace("../../index.php?file=jupload/jupload${parameters}"); 
	</script>
EOS;
	exit;	
}

//Ok, now we are within JUpload
// Note: define('JUPLOAD_PHP', true);  is executed in jupload_page_start (codebase.php)



//####################################################################################################
//#################################     INCLUDES    ##################################################
//####################################################################################################

// Activate more language block sets.
define('UPLOAD_PHP', true);
define('ADMIN_PHP', true);
define('ALBMGR_PHP', true); // added this line as workaround for missing translation of *no category*. Should be removed in next version. GauGau 2005-08-09
define('CATMGR_PHP', true);
define('GROUPMGR_PHP', true);
define('DB_INPUT_PHP', true);
define('DISPLAYIMAGE_PHP', true);
define('EDITPICS_PHP', true);
define('INDEX_PHP', true);



//A 'hack' to manage JUpload internal session when uploading files: we have to set 
//Coppermine user's constants before init.inc.php.
if (isset($_GET['action']) && $_GET['action'] == 'upload_picture') {
	// If the plugin is configure to use JUpload internal session management: we must not go to bridge 
	//includes now. We first load $USER_DATA and define constants from JUpload session management.
	require_once('plugins/jupload/include/session.inc.php');
	loadJuploadInternalSessionIfConfiguredTo();
}
//Then, let's go on

// Call basic functions, etc.
require_once('include/init.inc.php');
require_once('plugins/jupload/include/gui.inc.php');

//We may have some specific output to do (see loadJuploadInternalSessionIfConfiguredTo() function)
echo ($jupload_toBeEchoed);
if (isset($jupload_USER_DATA)) {
	//If we got here, the loadJuploadInternalSessionIfConfiguredTo has been called, and initialized $USER_DATA. 
	//This means that the plugin is using its internal session management.
	//But the include of init.inc.php overrided these values, so, we restaure our USER_DATA:
	$USER_DATA = $jupload_USER_DATA;
}


// Some placeholders.
$customize = CUSTOMIZE_UPLOAD_FORM;
$user_form = USER_UPLOAD_FORM;
$allowed_URI_boxes = NUM_URI_BOXES;
$allowed_file_boxes = NUM_FILE_BOXES;


//####################################################################################################
//##########################  CHECK IF THE USER MAY ENTER THE PLUGIN  ################################
//####################################################################################################


//If the user may not use the plugin, we display the standard error message.
//$jupload_user_may_use_jupload comes from jupload_page_start() in codebase.php
if (!$jupload_user_may_use_jupload) {
    $msg = 
    	str_replace(
			'$1', 
			'login.php?referer=plugins/jupload/jupload.php', 
			$lang_jupload_php['perm_denied'])
		;
	
	//When in upload_picture, we must return a simple file text (no HTML), so that the applet
	//can read it.
 	if (isset($_GET['action']) && $_GET['action'] == 'upload_picture') {
 		die($msg);
 	} else {		
    	cpg_die(ERROR, $msg, __FILE__, __LINE__);
 	}    
}


// ???????????????????????
// Globalize $CONFIG.
global $CONFIG, $user_form, $max_file_size;


//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################



//####################################################################################################
//#############################  INIT OF SCRIPT VARIABLES  ###########################################
//####################################################################################################

//Initialize local parameters.
$category			= isset($_POST['category']			) 
							? ( (int) $_POST['category'])	
							: (
								isset($_GET['category'])
									? (int)$_GET['category']
									: (
										isset($_GET['cat'])		//Coppermine uses 'cat' get parameter.
											? (int) $_GET['cat']
											: 0
									  )
							   );
$action				= isset($_POST['action']			) ? $_POST['action'] 			: (isset($_GET['action'])? $_GET['action']   :'');
$album				= isset($_POST['album']				) ? ( (int) $_POST['album']) 	: (isset($_GET['album'] )?(int)$_GET['album']:0);
$album_name			= isset($_POST['album_name']		) ? $_POST['album_name'] 		: '';
$album_description	= isset($_POST['album_description'] ) ? $_POST['album_description'] : '';
if (isset($_GET['jupart']) && isset($_GET['jufinal'])) {
	$chunkedUpload = true;
	$jupart  = (int) $_GET['jupart'];
	$jufinal = (int) $_GET['jufinal'];
} else {
	$chunkedUpload = false;
}

if (isset($_GET['jupload_session'])) {
	$juploadInternalSessionId = (int) $_GET['jupload_session'];
} 


/////////////////////////////////////////////////////////////////////////////////////////////////////
//  Control for the $category and $album parameters
/////////////////////////////////////////////////////////////////////////////////////////////////////
/*
 * Rules are:
 * 
 * Controls that $category and $album are not integer has already been done.
 * 
 * In GALLERY_ADMIN_MODE or action=ajax_list_album_of_a_category
 * - $category must be a valid category,
 * - $category may be a user's album, only if $USER_DATA['can_create_albums'] is true. 
 * - $album is free (control has already been done that it's an integer)
 * - If both $category and $album are given, the album must be in this category. Otherwise, we clear the album
 * 
 * In non GALLERY_ADMIN_MODE:
 * - $category must be a valid category. If category is not given, or is invalid, the user gallery is used.
 * - $category may be a user's album, only if $USER_DATA['can_create_albums'] is true. 
 * - $album may be one of these:
 *   * his user's album
 *   * a public album where his group may upload
 * - If both $category and $album are given, the album must be in this category. Otherwise, we clear the album
 * If upload is accepted to this album, the category is initialized to this category.
 * 
 */

//If $album is set, but not $category, we look for the album's category.
if ($category <= 0 && $album > 0) {
	//Let's find the category for this album. We'll check later if this category is Ok for the current user.
	$result = cpg_db_query(
			" SELECT category " .
			" FROM {$CONFIG['TABLE_ALBUMS']} " .
			" WHERE aid = $album "
			);
	$row = mysql_fetch_array($result);
	$category = $row ? $row['category'] : 0;
}

//In user admin mode, if the category wa not give, and doesn't correspond to the previous check,
//we replace it by the user's gallery.
if ($USER_DATA['can_create_albums'] && $category <= 0) {
	$category = FIRST_USER_CAT + USER_ID;
}


//if $category is set, we check that it's a valid category
if ($category > 0) {
	if (CAN_CREATE_ALBUM && $category == (FIRST_USER_CAT + USER_ID)) {
		$result = 1;
		$current_category 	= array(
						'cid' => FIRST_USER_CAT + USER_ID, 
						'name' => $lang_groupmgr_php['personal_gallery'], 
						'parent' => '0', 
						'description' => '');
	} else if (GALLERY_ADMIN_MODE) {
		$result = cpg_db_query(
				" SELECT cid, name, parent, description " .
				" FROM {$CONFIG['TABLE_CATEGORIES']} " .
				" WHERE cid = $category " . 
				" AND   cid > 0 " .
				" AND   cid < " . FIRST_USER_CAT
				);
		$current_category = mysql_fetch_array($result);
	} else {
		$result = cpg_db_query(
				" SELECT cid, name, parent, description " .
				" FROM {$CONFIG['TABLE_CATEGORIES']} " .
				" WHERE cid = $category " . 
				" AND   (cid < " . FIRST_USER_CAT . " or cid = " . (FIRST_USER_CAT + USER_ID) . ")"
				);
		$current_category = mysql_fetch_array($result);
	}
	
	//If we found a category, we've already stored it. Otherwise, we force it to 0.
	if (!$current_category) {
		$current_category 	= array('cid' => '0', 'name' => '', 'parent' => '0', 'description' => '');
	}
	$category = $current_category['cid'];
}

//If the category is still set (was set and accepted by the previous check), we
//can check the album
if ($category>0 && $album>0) {
	//Let's check that the album exists, and the user has right to have access to it. In JUpload
	//access means 'right to upload to it'.
	if (GALLERY_ADMIN_MODE) {
		$result = cpg_db_query(
				" SELECT aid " .
				" FROM {$CONFIG['TABLE_ALBUMS']} a" .
				" WHERE a.category = $category " .
				" AND   a.aid = $album "
				);
	} else {
		$result = cpg_db_query(
				" SELECT aid " .
				" FROM {$CONFIG['TABLE_ALBUMS']} a " .
				" WHERE category = $category " .
				" AND   a.aid = $album " .
				" AND " .
				"  ( " .
				"     ( " .
				"		a.category < " . FIRST_USER_CAT .
				"		AND a.uploads='YES' " .
				"		AND (a.visibility = '0' OR a.visibility IN ".USER_GROUP_SET.")" .
				"		AND " . (CAN_CREATE_ALBUM ? '1=1 ' : '1=2') .
				"      ) " .
				"  OR " .
				"     ( " .
				" 		a.category ='" . (FIRST_USER_CAT + USER_ID) . "'" . 
				"		AND " . (CAN_UPLOAD_PICTURE ? '1=1 ' : '1=2')  .
				"      ) " .
				"  ) "
				);
	}
	//If we have a result, the album is valid.
	$row = mysql_fetch_row($result);
	//Otherwise, we clear the album, as the user doesn't have access to it.
	if (!$row) {
		$album = 0;
	}	
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
//  End of controls for the $category and $album parameters
/////////////////////////////////////////////////////////////////////////////////////////////////////

//Override the SELF address, to add the album and category link, if any
$JUPLOAD_VAR['SELF'] = 'index.php?file=jupload/jupload'
	. ( $album>0 ? "&album=$album" : '')	
	. ( $category>0 ? "&category=$category" : '')	
;






//####################################################################################################
//################################# MAIN CODE BLOCK ##################################################
//####################################################################################################


///////////////////////////////////////////////////////////////////////
/////////////////   HANDLE OF INCOMING ACTIONS  (if any)  /////////////
///////////////////////////////////////////////////////////////////////

switch ($action) {
//First: generation of the standard jupload page, containing the applet:
case '':
case 'update_album':
case 'create_album':
case 'upload_page':
	require("$juploadRootDirectory/page/upload_page.php");
	break;
//Upload of a picture from the applet. No HTML to generate.
case 'upload_picture':
	require("$juploadRootDirectory/page/upload_picture.php");
	break;
//Edition of the properties of the uploaded pictures:
case 'ajax_list_album_of_a_category':
	require("$juploadRootDirectory/page/ajax_list_album_of_a_category.php");
	break;
case 'edit_uploaded_pics':
	require("$juploadRootDirectory/page/edit_uploaded_pics.php");
	break;
case 'config':
case 'store_config':
	require("$juploadRootDirectory/page/config_page.php");
	break;
case 'log_error':
	require("$juploadRootDirectory/page/log_error.php");
	break;
case 'display_error':
	$text = $_GET['text'];
	$msg = $lang_jupload_php[$text];
	cpg_die(ERROR, $msg, __FILE__, __LINE__);
default:
	cpg_die (ERROR, 'JUpload: Unknown action value', __FILE__, __LINE__);
}


//Let's send the output data.
ob_end_flush();



